Imports System.Data
Imports System.Drawing
Imports System.IO
Imports System.Xml
Imports System.Text
Imports System.Xml.Serialization
Imports System.Web.UI.WebControls
Partial Class ucCustomDataGrid
    Inherits System.Web.UI.UserControl
    Public Enum NamedStyle
        CLASSIC
        CLORFUL
        PROFESSIONAL
        SIMPLE
        AUTUMN
        OCEANIA
        BROWNSUGAR
        SANDSKY
        RAINYDAY
        SLATE
        SNOWYPIE
        MOCHA
    End Enum
    'Private Variables
    Dim gvForecolor As Color
    Dim gvMode As Integer
    Dim grdStyle As Integer
    Private dsCustom As DataSet
    Private dsCONFIG As DataSet

    'Hide/Show all the buttons
    Public Property ShowAllButton() As Boolean
        Get
            Return trButtonRow.Visible
        End Get
        Set(ByVal value As Boolean)
            trButtonRow.Visible = value
        End Set
    End Property
    'Makes Delete button visible or invisible
    Public Property ShowDeleteButton() As Boolean
        Get
            Return btnDelete.Visible
        End Get
        Set(ByVal value As Boolean)
            btnDelete.Visible = value
        End Set
    End Property
    'Makes Submit button visible or invisible
    Public Property ShowSubmitButton() As Boolean
        Get
            Return btnSubmit.Visible
        End Get
        Set(ByVal value As Boolean)
            btnSubmit.Visible = value
        End Set
    End Property
    'Configure/Receive the Submit Button Text
    Public Property SubmitButtonText() As String
        Get
            Return btnSubmit.Text
        End Get
        Set(ByVal value As String)
            btnSubmit.Text = value
        End Set
    End Property
    'Configure/Receive the Delete Button Text
    Public Property DeleteButtonText() As String
        Get
            Return btnDelete.Text
        End Get
        Set(ByVal value As String)
            btnDelete.Text = value
        End Set
    End Property
#Region "Configure Grid View Properties"
    'Define the mode of a datagrid :Editable or Editable + ContainMenu or ViewOnly
    Public Property GridViewMode() As Integer
        Get
            Return gvMode
        End Get
        Set(ByVal value As Integer)
            gvMode = value
        End Set
    End Property
    'Change the ForeColor of DataGrid
    Public Property GridViewForeColor() As Color 'System.Drawing.Color
        Get
            grdvwGeneric.ForeColor = gvForecolor
        End Get
        Set(ByVal value As System.Drawing.Color)

        End Set
    End Property
    Public WriteOnly Property SetGridStyle() As NamedStyle
        Set(ByVal value As NamedStyle)
            GridStyle(value)
        End Set
    End Property
    Public WriteOnly Property SetDataSource() As DataSet
        Set(ByVal value As DataSet)
            dsCustom = value
        End Set
    End Property
    Public WriteOnly Property SetConfigSource() As DataSet
        Set(ByVal value As DataSet)
            dsCONFIG = value
        End Set
    End Property
    'Similar properties to follow................
#End Region

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Initialize()
    End Sub
    Private Sub Initialize()

        'Get dataset DS from the Database
        'DS will help in accomplishing the following tasks :-
        'Populate the datagrid
        'Set the Column name for the datagrid
        'Set the header for the datagrid
        'Decide whether a DATAGRID column can be changed to any regular control like button, dropdown or link button
        'Can Hide or Disable the controls present
        'Change the style for the datagrid
        'Provide column wise Sorting ability for datagrid 
        '.............some more...............

        'Assign everything using Property 
        'Define a private variable for every property.
        'Assign the appropriate value to that private variable from the DS above 

        If Not Page.IsPostBack Then
            ViewState("DataSet") = dsCustom
            ViewState("ConfigSet") = dsCONFIG
        Else
            dsCustom = ViewState("DataSet")
            dsCONFIG = ViewState("ConfigSet")
        End If
        BindDataGrid()

    End Sub
    Private Sub BindDataGrid()
        grdvwGeneric.DataSource = dsCustom
        grdvwGeneric.DataBind()
    End Sub
    Protected Sub btnSubmit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSubmit.Click
        'Do Something
    End Sub

    Protected Sub btnDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        'Write the Delete routine here
    End Sub

    ' This subroutine will convert the required column to regular 
    ' asp control like button, hyperlink, linkbutton, dropdown or 
    ' radiobutton as per requirement
    Private Sub GetCustomDataGridColumn(ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs)

        'Read from the Configuration DataSet
        Dim btnCustom As New Control

        For iType As Integer = 0 To dsCONFIG.Tables(0).Rows.Count - 1

            If dsCONFIG.Tables(0).Rows(iType)("ColumnType") = "LinkButton" Then
                Dim btn As New LinkButton
                btn.Text = e.Row.Cells(0).Text
                btn.CommandName = e.Row.Cells(1).Text
                btn.CommandArgument = e.Row.Cells(1).Text
                AddHandler btn.Command, AddressOf Checkin_Command
                btnCustom = btn

            ElseIf dsCONFIG.Tables(0).Rows(iType)("ColumnType") = "Button" Then
                Dim btn1 As New Button
                btn1.Text = e.Row.Cells(1).Text
                btn1.CommandName = e.Row.Cells(1).Text
                btn1.CommandArgument = e.Row.Cells(1).Text
                AddHandler btn1.Command, AddressOf Checkin_Command
                btnCustom = btn1

            ElseIf dsCONFIG.Tables(0).Rows(iType)("ColumnType") = "DropDownList" Then
                Dim btn2 As New DropDownList
                btn2.Text = e.Row.Cells(2).Text
                btn2.Items.Add("Select")
                btn2.Items.Add(e.Row.Cells(2).Text)
                btn2.AutoPostBack = True
                AddHandler btn2.SelectedIndexChanged, AddressOf Dropdown
                btnCustom = btn2

            ElseIf dsCONFIG.Tables(0).Rows(iType)("ColumnType") = "CheckBox" Then
                Dim btn3 As New CheckBox
                AddHandler btn3.CheckedChanged, AddressOf Check_Changed
                btnCustom = btn3
            End If

            e.Row.Cells(iType).Controls.Add(btnCustom)
        Next

    End Sub
    Protected Sub grdvwGeneric_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdvwGeneric.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            GetCustomDataGridColumn(e)
        End If
    End Sub
    Public Sub Checkin_Command(ByVal sender As Object, ByVal e As CommandEventArgs)
        TextBox1.Text = e.CommandArgument
    End Sub
    Public Sub Dropdown(ByVal sender As Object, ByVal e As System.EventArgs)
        TextBox1.Text = ""
        Dim drp As DropDownList = CType(sender, DropDownList)
        TextBox1.Text = drp.SelectedItem.Text
    End Sub
    Public Sub Check_Changed(ByVal sender As Object, ByVal e As System.EventArgs)

        TextBox1.Text = sender.ToString()
    End Sub

    Private Sub GridStyle(ByVal style As NamedStyle)
        Dim HEX As String = "&H"
        'Select Case style
        'Case NamedStyle.PROFESSIONAL
        With grdvwGeneric
            .AllowSorting = True
            .CellPadding = 4
            .ForeColor = Color.FromArgb(&H333333)  '333333 = &H333333 or &H7868228b
            .GridLines = GridLines.None
            .AutoGenerateColumns = True
            '.Font.Bold = True

            With .RowStyle
                .BackColor = Color.FromArgb(HEX + "F7F6F3") '"#F7F6F3"
                .ForeColor = Color.FromArgb(HEX + "333333") '"#333333"
            End With

            With .FooterStyle
                .BackColor = Color.FromArgb(HEX + "5D7B9D") '"#5D7B9D"
            End With

            With .PagerStyle
                .BackColor = Color.FromArgb(HEX + "284775")
                .ForeColor = Color.White
                .HorizontalAlign = HorizontalAlign.Center
            End With

            With .SelectedRowStyle
                .BackColor = Color.FromArgb(HEX + "E2DED6")
                .Font.Bold = True
                .ForeColor = Color.FromArgb(HEX + "333333")
            End With

            With .HeaderStyle
                .BackColor = Color.FromArgb(HEX + "5D7B9D")
                .Font.Bold = True
                .ForeColor = Color.White
            End With

            With .EditRowStyle
                .BackColor = Color.FromArgb(HEX + "999999")
                .HorizontalAlign = HorizontalAlign.Left
                .VerticalAlign = VerticalAlign.Middle
            End With

            With .AlternatingRowStyle
                .BackColor = Color.White
                .ForeColor = Color.FromArgb(HEX + "284775")
            End With

        End With
        'End Select

    End Sub
    '<asp:GridView AllowSorting="true" ID="grdvwFile" runat="server" 
    'CellPadding="4" ForeColor="#333333" GridLines="None"   AutoGenerateColumns="False">
    '<FooterStyle BackColor="#5D7B9D" Font-Bold="True" ForeColor="White" />
    '<RowStyle BackColor="#F7F6F3" ForeColor="#333333" />
    '<PagerStyle BackColor="#284775" ForeColor="White" HorizontalAlign="Center" />
    '<SelectedRowStyle BackColor="#E2DED6" Font-Bold="True" ForeColor="#333333" />
    '<HeaderStyle BackColor="#5D7B9D" Font-Bold="True" ForeColor="White" />
    '<EditRowStyle BackColor="#999999" HorizontalAlign="Left" VerticalAlign="Middle" />
    '<AlternatingRowStyle BackColor="White" ForeColor="#284775" /> 

    '<asp:GridView ID="grdvwRecord" runat="server" AllowSorting="True" CellPadding="4" ForeColor="#333333" GridLines="None"   AutoGenerateColumns="False">
    '<FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White"  />
    '<RowStyle BackColor="#EFF3FB" />
    '<PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
    '<SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
    '<HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
    '<EditRowStyle BackColor="#2461BF" HorizontalAlign="Left" VerticalAlign="Middle" />
    '<AlternatingRowStyle BackColor="White"  />   

End Class
